it-roy-ru.com

Как определить тип браузера и его версию

как я могу определить тип браузера и его версию в Rails. Я хочу поставить галочку на версии определенного браузера и, если не требуется версия браузера, попросить пользователя обновить ее. Я использую указанную ниже команду, но, поскольку она не соответствует стандартному шаблону, я не могу ее использовать.

request.env['HTTP_USER_AGENT'] 

Chrome out put is below
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/534.16 (KHTML, like Gecko) Chrome/10.0.648.205 Safari/534.16
Safari out put is below
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/533.21.1 (KHTML, like Gecko) Version/5.0.5 Safari/533.21.1
FireFox out put is below
Mozilla/5.0 (Windows NT 5.1; rv:2.0) Gecko/20100101 Firefox/4.0
Opera out put is below
Opera/9.80 (Windows NT 5.1; U; en) Presto/2.8.131 Version/11.10
Internet Explorer out put is below
Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; .NET CLR 2.0.50727)
22
Syed Raza

Попробуйте браузер драгоценный камень. Очень просто и может решить вашу цель.

Вы можете найти драгоценный камень Здесь очень прост в использовании.

23
Nishutosh Sharma

ПРИМЕЧАНИЕ. Будьте осторожны, некоторые поисковые системы воспринимают это как тип вторжения. См. (АГЕНТ ПОЛЬЗОВАТЕЛЯ HTTP HTTP)

 if request.env['HTTP_USER_AGENT'] =~ /[^\(]*[^\)]Chrome\//

или в случае Firefox

if request.env['HTTP_USER_AGENT'] =~ /[^\(]*[^\)]*[^\t]Firefox\//

и отметьте здесь, вы получите все, что вам нужно Gem браузера

browsers_detection_gem

и вот метод, который может обнаружить все браузеры, так что спокойный человек

def browser_detection
  result = request.env['HTTP_USER_AGENT']
  browser_compatible = ''
  if result =~ /Safari/
    unless result =~ /Chrome/
      version = result.split('Version/')[1].split(' ').first.split('.').first
      browser_compatible = 'Application is not functional for Safari version\'s '+version if version.to_i < 5
    else
      version = result.split('Chrome/')[1].split(' ').first.split('.').first
      browser_compatible = 'Application is not functional for Chrome version\'s '+version if version.to_i < 10
    end
  elsif result =~ /Firefox/
    version = result.split('Firefox/')[1].split('.').first
    browser_compatible = 'Application is not functional for Firefox version\'s '+version if version.to_i < 5
  elsif result =~ /Opera/
    version = result.split('Version/')[1].split('.').first
    browser_compatible = 'Application is not functional for Opera version\'s '+version if version.to_i < 11
  elsif result =~ /MSIE/
    version = result.split('MSIE')[1].split(' ').first
    browser_compatible = 'Application is not functional for Microsoft Internet Explorer version\'s '+version if version.to_i < 9
  end
  browser_compatible
end
27
TH Afridi

Также есть useragent gem:

<% user_agent = UserAgent.parse(request.env["HTTP_USER_AGENT"]) %>
App: <%= user_agent.application %> # Mozilla/5.0 (Macintosh; Intel Mac OS X 10.8; rv:22.0)
Browser: <%= user_agent.browser %> # Firefox
Version: <%= user_agent.version %> # 22.0
Platform: <%= user_agent.platform %> # Macintosh
Mobile: <%= user_agent.mobile? %> # False
OS: <%= user_agent.os %> # OS X 10.8
9
Chris Edwards

То, что вы делаете, на самом деле способ сделать это. Теперь вы можете обрабатывать информацию агента пользователя с помощью регулярного выражения, ища совпадения в Firefox, Chrome или любом другом браузере или версии, которые вам нравятся.

3
Spyros

Несмотря на то, что это внешнее решение, я предпочитаю проверять наличие определенных функций, таких как flexbox. Вы можете использовать что-то вроде Modernizr , или подойдет простая проверка JavaScript ( https://stackoverflow.com/a/27047981/179311 ).

if(!("flexWrap" in document.documentElement.style)) {
    // IE 10, Chrome 20 and Firefox 27 and anything older will hit this.
    alert('your browser is out of date');
    // maybe this is preferred
    // window.location = '/browser-unsupported'
}
0
bradlis7